 program-id. fontawesome.

 working-storage section.
 copy "iscrt.def".
 copy "isgui.def".
 copy "isfonts.def".
 77  crt-status              special-names crt status pic 9(4).

 77  h-font                  handle of font.
 77  h-font-icon             pic s9(9) comp-4.

 77  font-name               pic x any length.
 77  icon-characters         pic n any length.
 77  icon-color              pic s9(9) value -7057.

 77  character-1-hex         pic x(4).
 77  character-2-hex         pic x(4).
 77  character-3-hex         pic x(4).

 77  character-1-n           pic n(1).
 77  character-1-red         pic x(2) comp-x 
                                      redefines character-1-n.

 77  character-2-n           pic n(1).
 77  character-2-red         pic x(2) comp-x 
                                      redefines character-2-n.

 77  character-3-n           pic n(1).
 77  character-3-red         pic x(2) comp-x 
                                      redefines character-3-n.
 77  hWin                    handle of window.
 77  close-win               pic 9 value 0.

 screen section.
 01 Mask.
    03 ef-1 
          entry-field
          line                       5
          col                        15
          size                       20 cells
          lines                      2.0 cells
          bitmap-handle              h-font-icon
          bitmap-width               20
          bitmap-number              1
          .

    03 pb-1
          push-button
          line                       9
          col                        15
          lines                      2.0 cells
          size                       20 cells
          bitmap-handle              h-font-icon
          bitmap-width               20
          title-position             2
          title                      "Option A"
          bitmap-number              2
          .
    03 pb-2
          push-button
          line                       13
          col                        15
          lines                      2.0 cells
          size                       20 cells
          bitmap-handle              h-font-icon
          bitmap-width               20
          title-position             2
          title                      "Option B"
          bitmap-number              3
          .


 procedure division.
 main.
   perform create-and-load-font
   display standard graphical window
           background-low  
           line 2
           col 65
           title  "FontAwesome Example"
           lines 20 
           size 50 
           control font default-font  
           handle hWin 
           event  win-evt

   display Mask

   perform until crt-status = 27 or close-win = 1
     accept Mask
        on exception continue 
     end-accept
   end-perform

   destroy Mask
   destroy hWin

   goback.

 create-and-load-font.
   perform load-font-from-name
   perform load-icon-from-font
   .

 load-font-from-name.
   move "Font Awesome 5 Free Solid" to font-name
   call "w$createfont" 
        using "files/Font Awesome 5 Free-Solid-900.otf" 
              font-name

   initialize wfont-data
   set wfdevice-console to true
   move font-name       to wfont-name
   move 10              to wfont-size
   call "w$font" 
           using wfont-get-font
                 h-font
                 wfont-data
   .

 load-icon-from-font.
   move "f1c3" to character-1-hex
   move "f576" to character-2-hex
   move "f008" to character-3-hex

   move function hex2dec(character-1-hex) to character-1-red
   move function hex2dec(character-2-hex) to character-2-red
   move function hex2dec(character-3-hex) to character-3-red

   initialize icon-characters 
   string character-1-n delimited by space 
                  character-2-n delimited by space 
                  character-3-n delimited by space 
                  into icon-characters.

   call "w$bitmap" 
             using wbitmap-load-symbol-font, 
                   h-font
                   icon-characters
                   20
                   icon-color
            giving h-font-icon.
           .


 win-evt.
    if event-type = cmd-close
       move 1 to close-win
    end-if
           .

